/* SPIM S20 MIPS simulator.
   Copyright (C) 1990 by James Larus (larus@cs.wisc.edu).

   Macintosh Version by Philip Delaquess (delaques@gcg.com)
   Copyright (C) 1993 by Saunders College Publishing and Morgan Kaufman Publishers.

   SPIM is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 1, or (at your option) any
   later version.

   SPIM is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.

   You should have received a copy of the GNU General Public License
   along with GNU CC; see the file COPYING.  If not, write to James R.
   Larus, Computer Sciences Department, University of Wisconsin--Madison,
   1210 West Dayton Street, Madison, WI 53706, USA or to the Free
   Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/

typedef struct {
	WindowPtr window;
	TEHandle text;
	ControlHandle vScroll, hScroll;
	short linesPerPage, columnsPerPage;
} SPIMTextWindow;

extern SPIMTextWindow Registers, Text, Data, Console, Session, Help;

void FormatRegisters(void);
void FormatText(void);
void FormatData(void);

void InitTextWindows(void);

void SelectTextWindow();
void ActivateTextWindow(WindowPtr window, Boolean active);
void UpdateTextWindow(WindowPtr window);
void RecalculateTextWindow(WindowPtr window);
void SizeTextWindow(WindowPtr window, Point start);
void TileTextWindows(Boolean vertically);
void ClickTextWindow(WindowPtr window, EventRecord *event);

void CountText(void);
void CountData(void);